## DataNode
`DataNode` is the base class of the `DataNodeContainer`, `ChannelDataNode` and
`LimaImageChannelDataNode` classes.

This object cannot have children nodes.

### Attributes

* `db_name`: the full name of the node. Reflects the position of the node in the tree of nodes.
* `name`: the short name for the node.
* `type`: the type of the node (str).
* `parent`: the parent node.
* `info`: info about the node.

### Methods

* `walk(self, include_filter=None, wait=True, ready_event=None)`
* `walk_events( include_filter=None, ready_event=None)`



## DataNodeContainer
`DataNodeContainer` class inherits from the DataNode class and can have a list
of children nodes.

* `type = container`

### Methods
* `add_children(*child)`
* `children(from_id=0, to_id=-1)`
* `last_child()`



## ChannelDataNode
`ChannelDataNode` class inherits from the `DataNode` class and is designed to
hold data.

* `type = channel`

### Attributes

* `shape`
* `dtype`
* `alias`

### Methods

* `get(from_index, to_index=None)`



## LimaImageChannelDataNode

### Methods

* `get(from_index, to_index=None)`



## Scan

This class inherit from the DataNodeContainer class and is designed for scans.

* `type = scan`
